"""
Just test the initial state.
"""

#imports for PyNN
import nealParams as nealParameters
#get the simulator
if (nealParameters.simulator=="spinnaker"):
    import pyNN.spiNNaker as sim
elif (nealParameters.simulator=="nest"):
    import pyNN.nest as sim
    import cPickle as pickle

from nealCoverClass import NealCoverFunctions
from cogmapClass import cogmapArea

def init():
    #print "spin" or nest
    sim.setup(timestep=nealParameters.DELAY,
              min_delay=nealParameters.DELAY,
              max_delay=nealParameters.DELAY, debug=0)

def runTest(time):
    sim.run(time)

def makeSpikeSource(inputTimes):
        inputSpikeTimes1 = inputTimes
        spikeArray1 = {'spike_times': [inputSpikeTimes1]}
        spikeGen1=sim.Population(1,sim.SpikeSourceArray,spikeArray1,
                                   label='inputSpikes_1')

        return spikeGen1

def testCellsOn(cm):
        spikeSource = makeSpikeSource(10.0)
        #turn on state0 that turns off all shapes.
        cm.fsa.turnOnStateFromSpikeSource(spikeSource,cm.stateCells,0)#PreExplore

#------------Main Body---------------
neal = NealCoverFunctions(nealParameters.simulator)
init()

cogmap = cogmapArea()
testCellsOn(cogmap)

runTest(nealParameters.SIM_LENGTH)

cogmap.printCogMapNets()
