import os

import sys
sys.path.append('./world/')
from getPixelsClass import imageToPixelClass

import nealParams as nealParameters

class nestVisionInputArea:
    fStaticFileInput = False

    def __init__(self):
        if (nealParameters.simulator=="nest"):
            print 'start nest vision input'
        else:
            print 'this should not be called for anything but nest'

        self.jpgDir = "world/data"
        self.imageTranslator = imageToPixelClass(nealParameters.INPSIZE) 

    def setStaticFileName(self,fileName):
        self.staticFileName = fileName
        self.fStaticFileInput = True

    def getStaticFileName(self):
        return self.staticFileName

    def useStaticFileName(self):
        return self.fStaticFileInput

    def getMostRecentFile(self):
        os.chdir(self.jpgDir)
        #get all the files
        files = os.listdir('.')

        #find the most recent file but 1 (as it may be writing the most recent)
        lastTime = 0.0
        lastTimeButOne = 0.0
        mostRecentFile = ""
        for file in files:
            fileTime = os.stat(file).st_ctime
            if (fileTime > lastTime):
                lastTimeButOne = lastTime
                lastTime = fileTime
                mostRecentFileButOne = mostRecentFile
                mostRecentFile = file
            elif (fileTime > lastTimeButOne):
                lastTimeButOne = lastTime
                mostRecentFileButOne = mostRecentFile
                
        if (os.access(mostRecentFile,os.W_OK)):
            fullFile = self.jpgDir+"/"+mostRecentFileButOne
        else:
            fullFile = self.jpgDir+"/"+mostRecentFile
        print fullFile
        os.chdir('../..')
        return fullFile

    def getPictureInput(self,fileName):
        print 'getPictureInput', fileName

        toSpinPic = self.imageTranslator.getPixelsFromFile(fileName)

        return toSpinPic
