#This builds and one state FSA driven by a spike source.
#The state should pop off the inhibitory neurons but persist.

import nealParams as nealParameters
#get the simulator
if  (nealParameters.simulator=="spinnaker"):
    import pyNN.spiNNaker as sim
elif (nealParameters.simulator=="nest"):
    import pyNN.nest as sim
    import cPickle as pickle
import numpy as np

from nealCoverClass import NealCoverFunctions
from stateMachineClass import FSAHelperFunctions

#---Below here are functions to test the system---
RUN_DURATION = 200

def connectSourceToState(stateCells):
    neal = NealCoverFunctions(nealParameters.simulator)

    #inputSpikeTimes = [16.0,20.0,29.0,44.0,48.0,57.0,74.0] #spinn
    inputSpikeTimes = [16.0,19.0,22.0, 25.0, 28.0, 36.0, 40.0, 44.0,48.0,57.0,74.0]
    #inputSpikeTimes = [16.0,20.0,29.0]
    spikeArray = {'spike_times': [inputSpikeTimes]}
    spikeGen=sim.Population(1,sim.SpikeSourceArray,spikeArray,
                                   label='inputSpikes')
    connector = []
    for toNeuron in range (10,18):
       connector = connector + [(0,toNeuron,0.16,1.0)]
    
    neal.nealProjection(spikeGen, stateCells, connector,'excitatory')


##--main---
neal = NealCoverFunctions(nealParameters.simulator)
fsa = FSAHelperFunctions(nealParameters.simulator)

fsa.testInit()

#make neurons and make them recordable
stateCells = fsa.testCreateNeurons()
fsa.testSetupRecording(stateCells)

#build the fsa and run it
fsa.makeCA(stateCells,1)
connectSourceToState(stateCells)

fsa.testRunFSA(RUN_DURATION)

#print results
fsa.testPrintResults(stateCells)



