#A tool for reading in the NEAL vision spike files and displaying them.
#It displays four different files.  Look for the colours (red, blue, green, 
#yellow and comment in the files you'd like.
from Tkinter import *
import numpy

gridSize = 20
screenSize = 525 #height and width
reserve = 25 #top and left
grid = screenSize -reserve
cellSize = grid/gridSize
readingNest = True


def drawGrid(canvas):
    for row in range (0,gridSize):
        rowY = reserve + (row*cellSize)
        canvas.create_text (10,rowY+5,text=row)
        canvas.create_line (reserve,rowY,screenSize,rowY)
    canvas.create_line (reserve,screenSize-1,screenSize,screenSize-1)
    for col in range (0,gridSize):
        colX = reserve + (col*cellSize)
        canvas.create_text (colX+5,10,text=col)
        canvas.create_line (colX,reserve,colX,screenSize)
    canvas.create_line (screenSize-1,reserve,screenSize-1,screenSize)

def drawCircle(canvas,cellRow,cellCol,circleRadius,circleColour):
    centreX = reserve + (cellSize*cellRow)+(cellSize/2)-circleRadius
    centreY = reserve + (cellSize*cellCol)+(cellSize/2)-circleRadius
    canvas.create_oval(centreX,centreY,
                       centreX+(circleRadius*2),centreY+(circleRadius*2),
                       fill=circleColour)

def addNestStringToArray(line):
    s = line.split()
    neuron = int(s[0])
    row = neuron/gridSize
    col = neuron%gridSize
    dataArray[col,row] = dataArray[col,row] + 1

def addStringToArray(line):
    s = line.split()
    time = s[0]
    neuron = int(float(s[1]))
    #print time,neuron
    row = neuron/gridSize
    col = neuron%gridSize
    dataArray[col,row] = dataArray[col,row] + 1

def printArray():
    for col in range (0,gridSize):
        for row in range (0,gridSize):
            if (dataArray[col,row] > 0):
                print col,row


def drawArray(canvas,color,radius):
    for col in range (0,gridSize):
        for row in range (0,gridSize):
            if (dataArray[col,row] > 0):
                drawCircle(canvas,col,row,radius,color)

def readNestFile(fileName):
    print 'nest'
    print fileName
    fileHandle = open(fileName)
    inputLine = fileHandle.readline()
    while (inputLine):
        addNestStringToArray(inputLine)
        inputLine = fileHandle.readline()
    
    fileHandle.close()

def readSpikeFile(fileName):
    if readingNest:
        readNestFile(fileName)
        return
    print fileName
    fileHandle = open(fileName)
    #ignore first four lines
    inputLine = fileHandle.readline()
    inputLine = fileHandle.readline()
    inputLine = fileHandle.readline()
    inputLine = fileHandle.readline()
    inputLine = fileHandle.readline()
    while (inputLine):
        addStringToArray(inputLine)
        inputLine = fileHandle.readline()
    
    fileHandle.close()

root = Tk()
canvas = Canvas (root,width=screenSize, height = screenSize)
canvas.pack()

drawGrid(canvas)

#params
directory = "../may16/results/"
directory = "../../cabot3/sep16/results/"
#directory = "../may16/results/bak/"
#directory = "../may16/results/bak30/"
#directory = "../may16/results/bak40/"
#directory = "../may16/results/bakpyr/"
#directory = "../may16/results/bakstal/"
directory = "results/"
print directory
dataArray = numpy.zeros((gridSize,gridSize))
readSpikeFile(directory+"visionBWInput.sp")
drawArray(canvas,"red",8)

dataArray = numpy.zeros((gridSize,gridSize))
#readSpikeFile(directory+"visionThreeOn.sp")
#readSpikeFile(directory+"visionThreeOff.sp")
#readSpikeFile(directory+"visionSixOn.sp")
#readSpikeFile(directory+"visionSixOff.sp")
#readSpikeFile(directory+"visionNineOn.sp")
#readSpikeFile(directory+"visionNineOff.sp")
#readSpikeFile(directory+"visionVEdgeLeft.sp")
readSpikeFile(directory+"visionBEdgeBottom.sp")
#readSpikeFile(directory+"visionSEdgeTop.sp")
drawArray(canvas,"blue",6)

dataArray = numpy.zeros((gridSize,gridSize))
#readSpikeFile(directory+"visionThreeOn.sp")
#readSpikeFile(directory+"visionThreeOff.sp")
#readSpikeFile(directory+"visionSixOn.sp")
#readSpikeFile(directory+"visionSixOff.sp")
#readSpikeFile(directory+"visionNineOn.sp")
readSpikeFile(directory+"visionNineOff.sp")
#readSpikeFile(directory+"visionVEdgeRight.sp")
#readSpikeFile(directory+"visionSEdgeBottom.sp")
#readSpikeFile(directory+"visionBEdgeBottom.sp")
#readSpikeFile(directory+"visionBEdgeTop.sp")
#readSpikeFile(directory+"visionHEdgeBottom.sp")
drawArray(canvas,"green",4)

dataArray = numpy.zeros((gridSize,gridSize))
#readSpikeFile(directory+"visionThreeOff.sp")
#readSpikeFile(directory+"visionSixOn.sp")
readSpikeFile(directory+"visionSixOff.sp")
#readSpikeFile(directory+"visionNineOff.sp")
#readSpikeFile(directory+"visionNineOn.sp")
#readSpikeFile(directory+"visionBEdgeTop.sp")
#readSpikeFile(directory+"visionBEdgeBottom.sp")
#readSpikeFile(directory+"visionSEdgeTop.sp")
#readSpikeFile(directory+"visionHEdgeTop.sp")
#readSpikeFile(directory+"visionHEdgeBottom.sp")
drawArray(canvas,"yellow",2)


#printArray()
root.mainloop()  
