import nealParams as nealParameters

threeOnExciteWeight = 0.2 
threeOffExciteWeight = 0.03 
sixOnExciteWeight = 0.03 
sixOffExciteWeight = 0.008 
nineOnExciteWeight = 0.014 
nineOffExciteWeight = 0.004 

if (nealParameters.simulator == 'nest'):
    threeOnInhibWeight = -0.1 
    threeOffInhibWeight = -0.7 
    sixOnInhibWeight = -0.015 
    sixOffInhibWeight =  -0.2 
    nineOnInhibWeight = -0.01 
    nineOffInhibWeight = -0.08 
elif (nealParameters.simulator == 'spinnaker'):
    threeOnInhibWeight = 0.1 
    threeOffInhibWeight = 0.7 
    sixOnInhibWeight = 0.015 
    sixOffInhibWeight =  0.2 
    nineOnInhibWeight = 0.01 
    nineOffInhibWeight = 0.08 


def addNewConn(pre,post,weight):
    if (pre >= 0) and (pre <  nealParameters.neuronsPerVisionSubnet):
        return [(pre,post,weight,nealParameters.DELAY)]
    else:
        return []

def get3x3OnExcite():
    connectors = []
    #for inpNeuron in range (0,nealParameters.neuronsPerVisionSubnet):
    for inpNeuron in range (nealParameters.INPSIZE,
                            nealParameters.neuronsPerVisionSubnet-
                            nealParameters.INPSIZE):
        connectors = connectors + [(inpNeuron,inpNeuron,threeOnExciteWeight,
                                    nealParameters.DELAY)]

    return connectors

def get3x3OnInhib():
    INPSIZE = nealParameters.INPSIZE
    weight = threeOnInhibWeight
    connectors = []
    for inpNeuron in range (0,nealParameters.neuronsPerVisionSubnet):
        col = inpNeuron % INPSIZE
        if (col > 0):
            newConn = addNewConn(inpNeuron-INPSIZE-1,inpNeuron,weight)
            connectors = connectors + newConn
            newConn = addNewConn(inpNeuron-1,inpNeuron,weight)
            connectors = connectors + newConn
            newConn = addNewConn(inpNeuron+INPSIZE-1,inpNeuron,weight)
            connectors = connectors + newConn
        newConn = addNewConn(inpNeuron-INPSIZE,inpNeuron,weight)
        connectors = connectors + newConn
        newConn = addNewConn(inpNeuron+INPSIZE,inpNeuron,weight)
        connectors = connectors + newConn
        if (col < (INPSIZE-1)):
            newConn = addNewConn(inpNeuron-INPSIZE+1,inpNeuron,weight)
            connectors = connectors + newConn
            newConn = addNewConn(inpNeuron+1,inpNeuron,weight)
            connectors = connectors + newConn
            newConn = addNewConn(inpNeuron+INPSIZE+1,inpNeuron,weight)
            connectors = connectors + newConn
    return connectors


def get3x3OffInhib():
    weight = threeOffInhibWeight
    connectors = []
    for inpNeuron in range (0,nealParameters.neuronsPerVisionSubnet):
        connectors = connectors + [(inpNeuron,inpNeuron,weight,
                                    nealParameters.DELAY)]
    return connectors

def get3x3OffExcite():
    INPSIZE = nealParameters.INPSIZE
    weight = threeOffExciteWeight
    connectors = []
    #for inpNeuron in range (0,nealParameters.neuronsPerVisionSubnet):
    for inpNeuron in range ((nealParameters.INPSIZE*2),
                            nealParameters.neuronsPerVisionSubnet-
                            (nealParameters.INPSIZE * 2)):
        col = inpNeuron % INPSIZE
        if (col > 0):
            newConn = addNewConn(inpNeuron-INPSIZE-1,inpNeuron,weight)
            connectors = connectors + newConn
            newConn = addNewConn(inpNeuron-1,inpNeuron,weight)
            connectors = connectors + newConn
            newConn = addNewConn(inpNeuron+INPSIZE-1,inpNeuron,weight)
            connectors = connectors + newConn
        newConn = addNewConn(inpNeuron-INPSIZE,inpNeuron,weight)
        connectors = connectors + newConn
        newConn = addNewConn(inpNeuron+INPSIZE,inpNeuron,weight)
        connectors = connectors + newConn
        if (col < (INPSIZE-1)):
            newConn = addNewConn(inpNeuron-INPSIZE+1,inpNeuron,weight)
            connectors = connectors + newConn
            newConn = addNewConn(inpNeuron+1,inpNeuron,weight)
            connectors = connectors + newConn
            newConn = addNewConn(inpNeuron+INPSIZE+1,inpNeuron,weight)
            connectors = connectors + newConn
    return connectors

def get6x6OnExcite():
    INPSIZE = nealParameters.INPSIZE
    weight = sixOnExciteWeight
    connectors = []
    for inpNeuron in range (0,nealParameters.neuronsPerVisionSubnet):
        col = inpNeuron % INPSIZE
        newConn = addNewConn(inpNeuron,inpNeuron,weight)
        connectors = connectors + newConn
        newConn = addNewConn(inpNeuron+INPSIZE,inpNeuron,weight)
        connectors = connectors + newConn
        if (col < (INPSIZE-1)):
            newConn = addNewConn(inpNeuron+1,inpNeuron,weight)
            connectors = connectors + newConn
            newConn = addNewConn(inpNeuron+INPSIZE+1,inpNeuron,weight)
            connectors = connectors + newConn
    return connectors

def get6x6OnInhib():
    INPSIZE = nealParameters.INPSIZE
    weight = sixOnInhibWeight
    connectors = []

    for inpNeuron in range (0,nealParameters.neuronsPerVisionSubnet):
        col = inpNeuron % INPSIZE
        newConn = addNewConn(inpNeuron-(2*INPSIZE),inpNeuron,weight)
        connectors = connectors + newConn
        newConn = addNewConn(inpNeuron-INPSIZE,inpNeuron,weight)
        connectors = connectors + newConn
        newConn = addNewConn(inpNeuron+(2*INPSIZE),inpNeuron,weight)
        connectors = connectors + newConn
        newConn = addNewConn(inpNeuron+(3*INPSIZE),inpNeuron,weight)
        connectors = connectors + newConn
        if (col > 1):
            newConn = addNewConn(inpNeuron-(2*INPSIZE)-2,inpNeuron,weight)
            connectors = connectors + newConn
            newConn = addNewConn(inpNeuron-INPSIZE-2,inpNeuron,weight)
            connectors = connectors + newConn
            newConn = addNewConn(inpNeuron-2,inpNeuron,weight)
            connectors = connectors + newConn
            newConn = addNewConn(inpNeuron+INPSIZE-2,inpNeuron,weight)
            connectors = connectors + newConn
            newConn = addNewConn(inpNeuron+(2*INPSIZE)-2,inpNeuron,weight)
            connectors = connectors + newConn
            newConn = addNewConn(inpNeuron+(3*INPSIZE)-2,inpNeuron,weight)
            connectors = connectors + newConn
        if (col > 0):
            newConn = addNewConn(inpNeuron-(2*INPSIZE)-1,inpNeuron,weight)
            connectors = connectors + newConn
            newConn = addNewConn(inpNeuron-INPSIZE-1,inpNeuron,weight)
            connectors = connectors + newConn
            newConn = addNewConn(inpNeuron-1,inpNeuron,weight)
            connectors = connectors + newConn
            newConn = addNewConn(inpNeuron+INPSIZE-1,inpNeuron,weight)
            connectors = connectors + newConn
            newConn = addNewConn(inpNeuron+(2*INPSIZE)-1,inpNeuron,weight)
            connectors = connectors + newConn
            newConn = addNewConn(inpNeuron+(3*INPSIZE)-1,inpNeuron,weight)
            connectors = connectors + newConn
        if (col < (INPSIZE-1)): 
            newConn = addNewConn(inpNeuron-(2*INPSIZE)+1,inpNeuron,weight)
            connectors = connectors + newConn
            newConn = addNewConn(inpNeuron-INPSIZE+1,inpNeuron,weight)
            connectors = connectors + newConn
            newConn = addNewConn(inpNeuron+(2*INPSIZE)+1,inpNeuron,weight)
            connectors = connectors + newConn
            newConn = addNewConn(inpNeuron+(3*INPSIZE)+1,inpNeuron,weight)
            connectors = connectors + newConn
        if (col < (INPSIZE-2)): 
            newConn = addNewConn(inpNeuron-(2*INPSIZE)+2,inpNeuron,weight)
            connectors = connectors + newConn
            newConn = addNewConn(inpNeuron-INPSIZE+2,inpNeuron,weight)
            connectors = connectors + newConn
            newConn = addNewConn(inpNeuron+2,inpNeuron,weight)
            connectors = connectors + newConn
            newConn = addNewConn(inpNeuron+(1*INPSIZE)+2,inpNeuron,weight)
            connectors = connectors + newConn
            newConn = addNewConn(inpNeuron+(2*INPSIZE)+2,inpNeuron,weight)
            connectors = connectors + newConn
            newConn = addNewConn(inpNeuron+(3*INPSIZE)+2,inpNeuron,weight)
            connectors = connectors + newConn
        if (col < (INPSIZE-3)):
            newConn = addNewConn(inpNeuron-(2*INPSIZE)+3,inpNeuron,weight)
            connectors = connectors + newConn
            newConn = addNewConn(inpNeuron-INPSIZE+3,inpNeuron,weight)
            connectors = connectors + newConn
            newConn = addNewConn(inpNeuron+3,inpNeuron,weight)
            connectors = connectors + newConn
            newConn = addNewConn(inpNeuron+INPSIZE+3,inpNeuron,weight)
            connectors = connectors + newConn
            newConn = addNewConn(inpNeuron+(2*INPSIZE)+3,inpNeuron,weight)
            connectors = connectors + newConn
            newConn = addNewConn(inpNeuron+(3*INPSIZE)+3,inpNeuron,weight)
            connectors = connectors + newConn
    #print len(connectors)
    #print connectors
    return connectors


def get6x6OffInhib():
    INPSIZE = nealParameters.INPSIZE
    weight = sixOffInhibWeight
    connectors = []
    for inpNeuron in range (0,nealParameters.neuronsPerVisionSubnet):
        col = inpNeuron % INPSIZE
        newConn = addNewConn(inpNeuron,inpNeuron,weight)
        connectors = connectors + newConn
        newConn = addNewConn(inpNeuron+INPSIZE,inpNeuron,weight)
        connectors = connectors + newConn
        if (col < (INPSIZE-1)):
            newConn = addNewConn(inpNeuron+1,inpNeuron,weight)
            connectors = connectors + newConn
            newConn = addNewConn(inpNeuron+INPSIZE+1,inpNeuron,weight)
            connectors = connectors + newConn
    #print connectors
    return connectors


def get6x6OffExcite():
    INPSIZE = nealParameters.INPSIZE
    weight = sixOffExciteWeight
    connectors = []

    for inpNeuron in range (0,nealParameters.neuronsPerVisionSubnet):
        col = inpNeuron % INPSIZE
        newConn = addNewConn(inpNeuron-(2*INPSIZE),inpNeuron,weight)
        connectors = connectors + newConn
        newConn = addNewConn(inpNeuron-INPSIZE,inpNeuron,weight)
        connectors = connectors + newConn
        newConn = addNewConn(inpNeuron+(2*INPSIZE),inpNeuron,weight)
        connectors = connectors + newConn
        newConn = addNewConn(inpNeuron+(3*INPSIZE),inpNeuron,weight)
        connectors = connectors + newConn
        if (col > 1):
            newConn = addNewConn(inpNeuron-(2*INPSIZE)-2,inpNeuron,weight)
            connectors = connectors + newConn
            newConn = addNewConn(inpNeuron-INPSIZE-2,inpNeuron,weight)
            connectors = connectors + newConn
            newConn = addNewConn(inpNeuron-2,inpNeuron,weight)
            connectors = connectors + newConn
            newConn = addNewConn(inpNeuron+INPSIZE-2,inpNeuron,weight)
            connectors = connectors + newConn
            newConn = addNewConn(inpNeuron+(2*INPSIZE)-2,inpNeuron,weight)
            connectors = connectors + newConn
            newConn = addNewConn(inpNeuron+(3*INPSIZE)-2,inpNeuron,weight)
            connectors = connectors + newConn
        if (col > 0):
            newConn = addNewConn(inpNeuron-(2*INPSIZE)-1,inpNeuron,weight)
            connectors = connectors + newConn
            newConn = addNewConn(inpNeuron-INPSIZE-1,inpNeuron,weight)
            connectors = connectors + newConn
            newConn = addNewConn(inpNeuron-1,inpNeuron,weight)
            connectors = connectors + newConn
            newConn = addNewConn(inpNeuron+INPSIZE-1,inpNeuron,weight)
            connectors = connectors + newConn
            newConn = addNewConn(inpNeuron+(2*INPSIZE)-1,inpNeuron,weight)
            connectors = connectors + newConn
            newConn = addNewConn(inpNeuron+(3*INPSIZE)-1,inpNeuron,weight)
            connectors = connectors + newConn
        if (col < (INPSIZE-1)): 
            newConn = addNewConn(inpNeuron-(2*INPSIZE)+1,inpNeuron,weight)
            connectors = connectors + newConn
            newConn = addNewConn(inpNeuron-INPSIZE+1,inpNeuron,weight)
            connectors = connectors + newConn
            newConn = addNewConn(inpNeuron+(2*INPSIZE)+1,inpNeuron,weight)
            connectors = connectors + newConn
            newConn = addNewConn(inpNeuron+(3*INPSIZE)+1,inpNeuron,weight)
            connectors = connectors + newConn
        if (col < (INPSIZE-2)): 
            newConn = addNewConn(inpNeuron-(2*INPSIZE)+2,inpNeuron,weight)
            connectors = connectors + newConn
            newConn = addNewConn(inpNeuron-INPSIZE+2,inpNeuron,weight)
            connectors = connectors + newConn
            newConn = addNewConn(inpNeuron+2,inpNeuron,weight)
            connectors = connectors + newConn
            newConn = addNewConn(inpNeuron+(1*INPSIZE)+2,inpNeuron,weight)
            connectors = connectors + newConn
            newConn = addNewConn(inpNeuron+(2*INPSIZE)+2,inpNeuron,weight)
            connectors = connectors + newConn
            newConn = addNewConn(inpNeuron+(3*INPSIZE)+2,inpNeuron,weight)
            connectors = connectors + newConn
        if (col < (INPSIZE-3)):
            newConn = addNewConn(inpNeuron-(2*INPSIZE)+3,inpNeuron,weight)
            connectors = connectors + newConn
            newConn = addNewConn(inpNeuron-INPSIZE+3,inpNeuron,weight)
            connectors = connectors + newConn
            newConn = addNewConn(inpNeuron+3,inpNeuron,weight)
            connectors = connectors + newConn
            newConn = addNewConn(inpNeuron+INPSIZE+3,inpNeuron,weight)
            connectors = connectors + newConn
            newConn = addNewConn(inpNeuron+(2*INPSIZE)+3,inpNeuron,weight)
            connectors = connectors + newConn
            newConn = addNewConn(inpNeuron+(3*INPSIZE)+3,inpNeuron,weight)
            connectors = connectors + newConn
    #print len(connectors)
    #print connectors
    return connectors

def get9x9OnExcite():
    INPSIZE = nealParameters.INPSIZE
    weight = nineOnExciteWeight
    connectors = []
    for inpNeuron in range (0,nealParameters.neuronsPerVisionSubnet):
        col = inpNeuron % INPSIZE
        newConn = addNewConn(inpNeuron,inpNeuron,weight)
        connectors = connectors + newConn
        newConn = addNewConn(inpNeuron+INPSIZE,inpNeuron,weight)
        connectors = connectors + newConn
        newConn = addNewConn(inpNeuron+(2*INPSIZE),inpNeuron,weight)
        connectors = connectors + newConn
        if (col < (INPSIZE-1)):
            newConn = addNewConn(inpNeuron+1,inpNeuron,weight)
            connectors = connectors + newConn
            newConn = addNewConn(inpNeuron+INPSIZE+1,inpNeuron,weight)
            connectors = connectors + newConn
            newConn = addNewConn(inpNeuron+(2*INPSIZE)+1,inpNeuron,weight)
            connectors = connectors + newConn
        if (col < (INPSIZE-2)):
            newConn = addNewConn(inpNeuron+2,inpNeuron,weight)
            connectors = connectors + newConn
            newConn = addNewConn(inpNeuron+INPSIZE+2,inpNeuron,weight)
            connectors = connectors + newConn
            newConn = addNewConn(inpNeuron+(2*INPSIZE)+2,inpNeuron,weight)
            connectors = connectors + newConn

    #print connectors
    return connectors


def get9x9OnInhib():
    INPSIZE = nealParameters.INPSIZE
    weight = nineOnInhibWeight
    connectors = []

    for inpNeuron in range (0,nealParameters.neuronsPerVisionSubnet):
        col = inpNeuron % INPSIZE
        newConn = addNewConn(inpNeuron-(3*INPSIZE),inpNeuron,weight)
        connectors = connectors + newConn
        newConn = addNewConn(inpNeuron-(2*INPSIZE),inpNeuron,weight)
        connectors = connectors + newConn
        newConn = addNewConn(inpNeuron-INPSIZE,inpNeuron,weight)
        connectors = connectors + newConn
        newConn = addNewConn(inpNeuron+(3*INPSIZE),inpNeuron,weight)
        connectors = connectors + newConn
        newConn = addNewConn(inpNeuron+(4*INPSIZE),inpNeuron,weight)
        connectors = connectors + newConn
        newConn = addNewConn(inpNeuron+(5*INPSIZE),inpNeuron,weight)
        connectors = connectors + newConn
        if (col > 2):
            newConn = addNewConn(inpNeuron-(3*INPSIZE)-3,inpNeuron,weight)
            connectors = connectors + newConn
            newConn = addNewConn(inpNeuron-(2*INPSIZE)-3,inpNeuron,weight)
            connectors = connectors + newConn
            newConn = addNewConn(inpNeuron-INPSIZE-3,inpNeuron,weight)
            connectors = connectors + newConn
            newConn = addNewConn(inpNeuron-3,inpNeuron,weight)
            connectors = connectors + newConn
            newConn = addNewConn(inpNeuron+INPSIZE-3,inpNeuron,weight)
            connectors = connectors + newConn
            newConn = addNewConn(inpNeuron+(2*INPSIZE)-3,inpNeuron,weight)
            connectors = connectors + newConn
            newConn = addNewConn(inpNeuron+(3*INPSIZE)-3,inpNeuron,weight)
            connectors = connectors + newConn
            newConn = addNewConn(inpNeuron+(4*INPSIZE)-3,inpNeuron,weight)
            connectors = connectors + newConn
            newConn = addNewConn(inpNeuron+(5*INPSIZE)-3,inpNeuron,weight)
            connectors = connectors + newConn
        if (col > 1):
            newConn = addNewConn(inpNeuron-(3*INPSIZE)-2,inpNeuron,weight)
            connectors = connectors + newConn
            newConn = addNewConn(inpNeuron-(2*INPSIZE)-2,inpNeuron,weight)
            connectors = connectors + newConn
            newConn = addNewConn(inpNeuron-INPSIZE-2,inpNeuron,weight)
            connectors = connectors + newConn
            newConn = addNewConn(inpNeuron-2,inpNeuron,weight)
            connectors = connectors + newConn
            newConn = addNewConn(inpNeuron+INPSIZE-2,inpNeuron,weight)
            connectors = connectors + newConn
            newConn = addNewConn(inpNeuron+(2*INPSIZE)-2,inpNeuron,weight)
            connectors = connectors + newConn
            newConn = addNewConn(inpNeuron+(3*INPSIZE)-2,inpNeuron,weight)
            connectors = connectors + newConn
            newConn = addNewConn(inpNeuron+(4*INPSIZE)-2,inpNeuron,weight)
            connectors = connectors + newConn
            newConn = addNewConn(inpNeuron+(5*INPSIZE)-2,inpNeuron,weight)
            connectors = connectors + newConn
        if (col > 0):
            newConn = addNewConn(inpNeuron-(3*INPSIZE)-1,inpNeuron,weight)
            connectors = connectors + newConn
            newConn = addNewConn(inpNeuron-(2*INPSIZE)-1,inpNeuron,weight)
            connectors = connectors + newConn
            newConn = addNewConn(inpNeuron-INPSIZE-1,inpNeuron,weight)
            connectors = connectors + newConn
            newConn = addNewConn(inpNeuron-1,inpNeuron,weight)
            connectors = connectors + newConn
            newConn = addNewConn(inpNeuron+INPSIZE-1,inpNeuron,weight)
            connectors = connectors + newConn
            newConn = addNewConn(inpNeuron+(2*INPSIZE)-1,inpNeuron,weight)
            connectors = connectors + newConn
            newConn = addNewConn(inpNeuron+(3*INPSIZE)-1,inpNeuron,weight)
            connectors = connectors + newConn
            newConn = addNewConn(inpNeuron+(4*INPSIZE)-1,inpNeuron,weight)
            connectors = connectors + newConn
            newConn = addNewConn(inpNeuron+(5*INPSIZE)-1,inpNeuron,weight)
            connectors = connectors + newConn
        if (col < (INPSIZE-1)): 
            newConn = addNewConn(inpNeuron-(3*INPSIZE)+1,inpNeuron,weight)
            connectors = connectors + newConn
            newConn = addNewConn(inpNeuron-(2*INPSIZE)+1,inpNeuron,weight)
            connectors = connectors + newConn
            newConn = addNewConn(inpNeuron-INPSIZE+1,inpNeuron,weight)
            connectors = connectors + newConn
            newConn = addNewConn(inpNeuron+(3*INPSIZE)+1,inpNeuron,weight)
            connectors = connectors + newConn
            newConn = addNewConn(inpNeuron+(4*INPSIZE)+1,inpNeuron,weight)
            connectors = connectors + newConn
            newConn = addNewConn(inpNeuron+(5*INPSIZE)+1,inpNeuron,weight)
            connectors = connectors + newConn
        if (col < (INPSIZE-2)): 
            newConn = addNewConn(inpNeuron-(3*INPSIZE)+2,inpNeuron,weight)
            connectors = connectors + newConn
            newConn = addNewConn(inpNeuron-(2*INPSIZE)+2,inpNeuron,weight)
            connectors = connectors + newConn
            newConn = addNewConn(inpNeuron-INPSIZE+2,inpNeuron,weight)
            connectors = connectors + newConn
            newConn = addNewConn(inpNeuron+(3*INPSIZE)+2,inpNeuron,weight)
            connectors = connectors + newConn
            newConn = addNewConn(inpNeuron+(4*INPSIZE)+2,inpNeuron,weight)
            connectors = connectors + newConn
            newConn = addNewConn(inpNeuron+(5*INPSIZE)+2,inpNeuron,weight)
            connectors = connectors + newConn
        if (col < (INPSIZE-3)):
            newConn = addNewConn(inpNeuron-(3*INPSIZE)+3,inpNeuron,weight)
            connectors = connectors + newConn
            newConn = addNewConn(inpNeuron-(2*INPSIZE)+3,inpNeuron,weight)
            connectors = connectors + newConn
            newConn = addNewConn(inpNeuron-INPSIZE+3,inpNeuron,weight)
            connectors = connectors + newConn
            newConn = addNewConn(inpNeuron+3,inpNeuron,weight)
            connectors = connectors + newConn
            newConn = addNewConn(inpNeuron+INPSIZE+3,inpNeuron,weight)
            connectors = connectors + newConn
            newConn = addNewConn(inpNeuron+(2*INPSIZE)+3,inpNeuron,weight)
            connectors = connectors + newConn
            newConn = addNewConn(inpNeuron+(3*INPSIZE)+3,inpNeuron,weight)
            connectors = connectors + newConn
            newConn = addNewConn(inpNeuron+(4*INPSIZE)+3,inpNeuron,weight)
            connectors = connectors + newConn
            newConn = addNewConn(inpNeuron+(5*INPSIZE)+3,inpNeuron,weight)
            connectors = connectors + newConn
        if (col < (INPSIZE-4)):
            newConn = addNewConn(inpNeuron-(3*INPSIZE)+4,inpNeuron,weight)
            connectors = connectors + newConn
            newConn = addNewConn(inpNeuron-(2*INPSIZE)+4,inpNeuron,weight)
            connectors = connectors + newConn
            newConn = addNewConn(inpNeuron-INPSIZE+4,inpNeuron,weight)
            connectors = connectors + newConn
            newConn = addNewConn(inpNeuron+4,inpNeuron,weight)
            connectors = connectors + newConn
            newConn = addNewConn(inpNeuron+INPSIZE+4,inpNeuron,weight)
            connectors = connectors + newConn
            newConn = addNewConn(inpNeuron+(2*INPSIZE)+4,inpNeuron,weight)
            connectors = connectors + newConn
            newConn = addNewConn(inpNeuron+(3*INPSIZE)+4,inpNeuron,weight)
            connectors = connectors + newConn
            newConn = addNewConn(inpNeuron+(4*INPSIZE)+4,inpNeuron,weight)
            connectors = connectors + newConn
            newConn = addNewConn(inpNeuron+(5*INPSIZE)+4,inpNeuron,weight)
            connectors = connectors + newConn
        if (col < (INPSIZE-5)):
            newConn = addNewConn(inpNeuron-(3*INPSIZE)+5,inpNeuron,weight)
            connectors = connectors + newConn
            newConn = addNewConn(inpNeuron-(2*INPSIZE)+5,inpNeuron,weight)
            connectors = connectors + newConn
            newConn = addNewConn(inpNeuron-INPSIZE+5,inpNeuron,weight)
            connectors = connectors + newConn
            newConn = addNewConn(inpNeuron+5,inpNeuron,weight)
            connectors = connectors + newConn
            newConn = addNewConn(inpNeuron+INPSIZE+5,inpNeuron,weight)
            connectors = connectors + newConn
            newConn = addNewConn(inpNeuron+(2*INPSIZE)+5,inpNeuron,weight)
            connectors = connectors + newConn
            newConn = addNewConn(inpNeuron+(3*INPSIZE)+5,inpNeuron,weight)
            connectors = connectors + newConn
            newConn = addNewConn(inpNeuron+(4*INPSIZE)+5,inpNeuron,weight)
            connectors = connectors + newConn
            newConn = addNewConn(inpNeuron+(5*INPSIZE)+5,inpNeuron,weight)
            connectors = connectors + newConn
    #print len(connectors)
    #print connectors
    return connectors

def get9x9OffInhib():
    INPSIZE = nealParameters.INPSIZE
    weight = nineOffInhibWeight
    connectors = []
    for inpNeuron in range (0,nealParameters.neuronsPerVisionSubnet):
        col = inpNeuron % INPSIZE
        newConn = addNewConn(inpNeuron,inpNeuron,weight)
        connectors = connectors + newConn
        newConn = addNewConn(inpNeuron+INPSIZE,inpNeuron,weight)
        connectors = connectors + newConn
        newConn = addNewConn(inpNeuron+(2*INPSIZE),inpNeuron,weight)
        connectors = connectors + newConn
        if (col < (INPSIZE-1)):
            newConn = addNewConn(inpNeuron+1,inpNeuron,weight)
            connectors = connectors + newConn
            newConn = addNewConn(inpNeuron+INPSIZE+1,inpNeuron,weight)
            connectors = connectors + newConn
            newConn = addNewConn(inpNeuron+(2*INPSIZE)+1,inpNeuron,weight)
            connectors = connectors + newConn
        if (col < (INPSIZE-2)):
            newConn = addNewConn(inpNeuron+2,inpNeuron,weight)
            connectors = connectors + newConn
            newConn = addNewConn(inpNeuron+INPSIZE+2,inpNeuron,weight)
            connectors = connectors + newConn
            newConn = addNewConn(inpNeuron+(2*INPSIZE)+2,inpNeuron,weight)
            connectors = connectors + newConn

    #print connectors
    return connectors

def get9x9OffExcite():
    INPSIZE = nealParameters.INPSIZE
    weight = nineOffExciteWeight
    connectors = []

    for inpNeuron in range (0,nealParameters.neuronsPerVisionSubnet):
        col = inpNeuron % INPSIZE
        newConn = addNewConn(inpNeuron-(3*INPSIZE),inpNeuron,weight)
        connectors = connectors + newConn
        newConn = addNewConn(inpNeuron-(2*INPSIZE),inpNeuron,weight)
        connectors = connectors + newConn
        newConn = addNewConn(inpNeuron-INPSIZE,inpNeuron,weight)
        connectors = connectors + newConn
        newConn = addNewConn(inpNeuron+(3*INPSIZE),inpNeuron,weight)
        connectors = connectors + newConn
        newConn = addNewConn(inpNeuron+(4*INPSIZE),inpNeuron,weight)
        connectors = connectors + newConn
        newConn = addNewConn(inpNeuron+(5*INPSIZE),inpNeuron,weight)
        connectors = connectors + newConn
        if (col > 2):
            newConn = addNewConn(inpNeuron-(3*INPSIZE)-3,inpNeuron,weight)
            connectors = connectors + newConn
            newConn = addNewConn(inpNeuron-(2*INPSIZE)-3,inpNeuron,weight)
            connectors = connectors + newConn
            newConn = addNewConn(inpNeuron-INPSIZE-3,inpNeuron,weight)
            connectors = connectors + newConn
            newConn = addNewConn(inpNeuron-3,inpNeuron,weight)
            connectors = connectors + newConn
            newConn = addNewConn(inpNeuron+INPSIZE-3,inpNeuron,weight)
            connectors = connectors + newConn
            newConn = addNewConn(inpNeuron+(2*INPSIZE)-3,inpNeuron,weight)
            connectors = connectors + newConn
            newConn = addNewConn(inpNeuron+(3*INPSIZE)-3,inpNeuron,weight)
            connectors = connectors + newConn
            newConn = addNewConn(inpNeuron+(4*INPSIZE)-3,inpNeuron,weight)
            connectors = connectors + newConn
            newConn = addNewConn(inpNeuron+(5*INPSIZE)-3,inpNeuron,weight)
            connectors = connectors + newConn
        if (col > 1):
            newConn = addNewConn(inpNeuron-(3*INPSIZE)-2,inpNeuron,weight)
            connectors = connectors + newConn
            newConn = addNewConn(inpNeuron-(2*INPSIZE)-2,inpNeuron,weight)
            connectors = connectors + newConn
            newConn = addNewConn(inpNeuron-INPSIZE-2,inpNeuron,weight)
            connectors = connectors + newConn
            newConn = addNewConn(inpNeuron-2,inpNeuron,weight)
            connectors = connectors + newConn
            newConn = addNewConn(inpNeuron+INPSIZE-2,inpNeuron,weight)
            connectors = connectors + newConn
            newConn = addNewConn(inpNeuron+(2*INPSIZE)-2,inpNeuron,weight)
            connectors = connectors + newConn
            newConn = addNewConn(inpNeuron+(3*INPSIZE)-2,inpNeuron,weight)
            connectors = connectors + newConn
            newConn = addNewConn(inpNeuron+(4*INPSIZE)-2,inpNeuron,weight)
            connectors = connectors + newConn
            newConn = addNewConn(inpNeuron+(5*INPSIZE)-2,inpNeuron,weight)
            connectors = connectors + newConn
        if (col > 0):
            newConn = addNewConn(inpNeuron-(3*INPSIZE)-1,inpNeuron,weight)
            connectors = connectors + newConn
            newConn = addNewConn(inpNeuron-(2*INPSIZE)-1,inpNeuron,weight)
            connectors = connectors + newConn
            newConn = addNewConn(inpNeuron-INPSIZE-1,inpNeuron,weight)
            connectors = connectors + newConn
            newConn = addNewConn(inpNeuron-1,inpNeuron,weight)
            connectors = connectors + newConn
            newConn = addNewConn(inpNeuron+INPSIZE-1,inpNeuron,weight)
            connectors = connectors + newConn
            newConn = addNewConn(inpNeuron+(2*INPSIZE)-1,inpNeuron,weight)
            connectors = connectors + newConn
            newConn = addNewConn(inpNeuron+(3*INPSIZE)-1,inpNeuron,weight)
            connectors = connectors + newConn
            newConn = addNewConn(inpNeuron+(4*INPSIZE)-1,inpNeuron,weight)
            connectors = connectors + newConn
            newConn = addNewConn(inpNeuron+(5*INPSIZE)-1,inpNeuron,weight)
            connectors = connectors + newConn
        if (col < (INPSIZE-1)): 
            newConn = addNewConn(inpNeuron-(3*INPSIZE)+1,inpNeuron,weight)
            connectors = connectors + newConn
            newConn = addNewConn(inpNeuron-(2*INPSIZE)+1,inpNeuron,weight)
            connectors = connectors + newConn
            newConn = addNewConn(inpNeuron-INPSIZE+1,inpNeuron,weight)
            connectors = connectors + newConn
            newConn = addNewConn(inpNeuron+(3*INPSIZE)+1,inpNeuron,weight)
            connectors = connectors + newConn
            newConn = addNewConn(inpNeuron+(4*INPSIZE)+1,inpNeuron,weight)
            connectors = connectors + newConn
            newConn = addNewConn(inpNeuron+(5*INPSIZE)+1,inpNeuron,weight)
            connectors = connectors + newConn
        if (col < (INPSIZE-2)): 
            newConn = addNewConn(inpNeuron-(3*INPSIZE)+2,inpNeuron,weight)
            connectors = connectors + newConn
            newConn = addNewConn(inpNeuron-(2*INPSIZE)+2,inpNeuron,weight)
            connectors = connectors + newConn
            newConn = addNewConn(inpNeuron-INPSIZE+2,inpNeuron,weight)
            connectors = connectors + newConn
            newConn = addNewConn(inpNeuron+(3*INPSIZE)+2,inpNeuron,weight)
            connectors = connectors + newConn
            newConn = addNewConn(inpNeuron+(4*INPSIZE)+2,inpNeuron,weight)
            connectors = connectors + newConn
            newConn = addNewConn(inpNeuron+(5*INPSIZE)+2,inpNeuron,weight)
            connectors = connectors + newConn
        if (col < (INPSIZE-3)):
            newConn = addNewConn(inpNeuron-(3*INPSIZE)+3,inpNeuron,weight)
            connectors = connectors + newConn
            newConn = addNewConn(inpNeuron-(2*INPSIZE)+3,inpNeuron,weight)
            connectors = connectors + newConn
            newConn = addNewConn(inpNeuron-INPSIZE+3,inpNeuron,weight)
            connectors = connectors + newConn
            newConn = addNewConn(inpNeuron+3,inpNeuron,weight)
            connectors = connectors + newConn
            newConn = addNewConn(inpNeuron+INPSIZE+3,inpNeuron,weight)
            connectors = connectors + newConn
            newConn = addNewConn(inpNeuron+(2*INPSIZE)+3,inpNeuron,weight)
            connectors = connectors + newConn
            newConn = addNewConn(inpNeuron+(3*INPSIZE)+3,inpNeuron,weight)
            connectors = connectors + newConn
            newConn = addNewConn(inpNeuron+(4*INPSIZE)+3,inpNeuron,weight)
            connectors = connectors + newConn
            newConn = addNewConn(inpNeuron+(5*INPSIZE)+3,inpNeuron,weight)
            connectors = connectors + newConn
        if (col < (INPSIZE-4)):
            newConn = addNewConn(inpNeuron-(3*INPSIZE)+4,inpNeuron,weight)
            connectors = connectors + newConn
            newConn = addNewConn(inpNeuron-(2*INPSIZE)+4,inpNeuron,weight)
            connectors = connectors + newConn
            newConn = addNewConn(inpNeuron-INPSIZE+4,inpNeuron,weight)
            connectors = connectors + newConn
            newConn = addNewConn(inpNeuron+4,inpNeuron,weight)
            connectors = connectors + newConn
            newConn = addNewConn(inpNeuron+INPSIZE+4,inpNeuron,weight)
            connectors = connectors + newConn
            newConn = addNewConn(inpNeuron+(2*INPSIZE)+4,inpNeuron,weight)
            connectors = connectors + newConn
            newConn = addNewConn(inpNeuron+(3*INPSIZE)+4,inpNeuron,weight)
            connectors = connectors + newConn
            newConn = addNewConn(inpNeuron+(4*INPSIZE)+4,inpNeuron,weight)
            connectors = connectors + newConn
            newConn = addNewConn(inpNeuron+(5*INPSIZE)+4,inpNeuron,weight)
            connectors = connectors + newConn
        if (col < (INPSIZE-5)):
            newConn = addNewConn(inpNeuron-(3*INPSIZE)+5,inpNeuron,weight)
            connectors = connectors + newConn
            newConn = addNewConn(inpNeuron-(2*INPSIZE)+5,inpNeuron,weight)
            connectors = connectors + newConn
            newConn = addNewConn(inpNeuron-INPSIZE+5,inpNeuron,weight)
            connectors = connectors + newConn
            newConn = addNewConn(inpNeuron+5,inpNeuron,weight)
            connectors = connectors + newConn
            newConn = addNewConn(inpNeuron+INPSIZE+5,inpNeuron,weight)
            connectors = connectors + newConn
            newConn = addNewConn(inpNeuron+(2*INPSIZE)+5,inpNeuron,weight)
            connectors = connectors + newConn
            newConn = addNewConn(inpNeuron+(3*INPSIZE)+5,inpNeuron,weight)
            connectors = connectors + newConn
            newConn = addNewConn(inpNeuron+(4*INPSIZE)+5,inpNeuron,weight)
            connectors = connectors + newConn
            newConn = addNewConn(inpNeuron+(5*INPSIZE)+5,inpNeuron,weight)
            connectors = connectors + newConn
    #print len(connectors)
    #print connectors
    return connectors




