#all this does is set up the timer to send an update from
#spinnaker to the environment
import nealParams as nealParameters
if (nealParameters.simulator=="spinnaker"):
    import pyNN.spiNNaker as sim
    import spynnaker_external_devices_plugin.pyNN as ExternalDevices
else:
    print "error spinnVisionInputClass.py misloaded"

from nealCoverClass import NealCoverFunctions
from stateMachineClass import FSAHelperFunctions

class spinnVisionInputArea:

    def __init__(self):
        print "init spinn vision input"
        self.neal = NealCoverFunctions(nealParameters.simulator)
        self.fsa = FSAHelperFunctions(nealParameters.simulator)
        self.fsa.initParams()
        #set up a timer CA that just stays on forever.
        self.visionTimerCells = sim.Population(self.fsa.CA_SIZE,
                sim.IF_cond_exp,self.fsa.CELL_PARAMS)
        self.fsa.makeCA(self.visionTimerCells,0)

        #start the timer
        spikeArray = {'spike_times': [10]}
        spikeGen=sim.Population(1,sim.SpikeSourceArray,spikeArray,
                                   label='inputSpikes_VisTimer')
        self.fsa.turnOnStateFromSpikeSource(spikeGen,self.visionTimerCells,0)

        #set up a neuron for the environment to monitor
        self.visionOutputCells = sim.Population(1,
                sim.IF_cond_exp, self.fsa.CELL_PARAMS,
                label="clockFromBoard")
        ExternalDevices.activate_live_output_for(self.visionOutputCells,
                                                 database_notify_port_num=12346)

        #connect the  timer CA to the output neuron
        wt = 0.025
        connector = []
        for fromNeuron in range (0,self.fsa.CA_SIZE):
            connector = connector+ [(fromNeuron,0,wt,
                                     nealParameters.DELAY)]
        self.neal.nealProjection(self.visionTimerCells, self.visionOutputCells, 
            connector,'excitatory')



