import nealParams as nealParameters

vEdgeLeftOrRightThreeOffExciteWeight = 0.03 
hEdgeTopOrBottomThreeOffExciteWeight = 0.03 
hEdgeTopOrBottomThreeOnExciteWeight = 0.04 
sEdgeTopOrBottomThreeOffExciteWeight =  0.03 
sEdgeTopOrBottomThreeOnExciteWeight = 0.03
bEdgeTopOrBottomThreeOffExciteWeight = 0.03 
bEdgeTopOrBottomThreeOnExciteWeight = 0.03

if (nealParameters.simulator == 'nest'):
    vEdgeLeftNineOffInhibWeight = -0.1
    vEdgeRightNineOffInhibWeight = -0.1
    hEdgeBottomSixOffInhibWeight = -0.1
    hEdgeBottomNineOffInhibWeight = -0.1
    hEdgeTopSixOffInhibWeight = -0.1
    hEdgeTopNineOffInhibWeight = -0.1
    sEdgeTopOrBottomSixOffInhibWeight = -0.1 
    sEdgeTopOrBottomNineOffInhibWeight = -0.1 
    sEdgeTopSixOffInhibWeight = -0.2 
    sEdgeTopNineOffInhibWeight = -0.2 
    sEdgeBottomNineOffInhibWeight = -0.2 
    sEdgeBottomSixOffInhibWeight = -0.2 
    bEdgeTopOrBottomSixOnInhibWeight = -0.1 
    bEdgeTopSixOffInhibWeight = -0.2
    bEdgeTopNineOffInhibWeight = -0.2 
    bEdgeBottomSixOffInhibWeight = -0.2
    bEdgeBottomNineOffInhibWeight = -0.2 
elif (nealParameters.simulator == 'spinnaker'):
    vEdgeLeftNineOffInhibWeight = 0.1
    vEdgeRightNineOffInhibWeight = 0.1
    hEdgeBottomSixOffInhibWeight = 0.1
    hEdgeBottomNineOffInhibWeight = 0.1
    hEdgeTopSixOffInhibWeight = 0.1
    hEdgeTopNineOffInhibWeight = 0.1
    sEdgeTopOrBottomSixOffInhibWeight = 0.1 
    sEdgeTopOrBottomNineOffInhibWeight = 0.1 
    sEdgeTopSixOffInhibWeight = 0.2 
    sEdgeTopNineOffInhibWeight = 0.2 
    sEdgeBottomNineOffInhibWeight = 0.2 
    sEdgeBottomSixOffInhibWeight = 0.2 
    bEdgeTopOrBottomSixOnInhibWeight = 0.1 
    bEdgeTopSixOffInhibWeight = 0.2 
    bEdgeTopNineOffInhibWeight = 0.2 
    bEdgeBottomSixOffInhibWeight = 0.2 
    bEdgeBottomNineOffInhibWeight = 0.2 


def addNewConn(pre,post,weight):
    if (pre >= 0) and (pre <  nealParameters.neuronsPerVisionSubnet):
        return [(pre,post,weight,nealParameters.DELAY)]
    else:
        return []

def getHEdgeTopOrBottomFrom3x3OnExcite():
    INPSIZE = nealParameters.INPSIZE
    weight = hEdgeTopOrBottomThreeOnExciteWeight
    connectors = []
    for inpNeuron in range (0,nealParameters.neuronsPerVisionSubnet):
        col = inpNeuron % INPSIZE
        if (col > 2):
            newConn = addNewConn(inpNeuron-3,inpNeuron,weight)
            connectors = connectors + newConn
        if (col > 1):
            newConn = addNewConn(inpNeuron-2,inpNeuron,weight)
            connectors = connectors + newConn
        if (col > 0):
            newConn = addNewConn(inpNeuron-1,inpNeuron,weight)
            connectors = connectors + newConn
        connectors = connectors + [(inpNeuron,inpNeuron,weight,
                                    nealParameters.DELAY)]
        if (col < (INPSIZE-1)):
            newConn = addNewConn(inpNeuron+1,inpNeuron,weight)
            connectors = connectors + newConn
        if (col < (INPSIZE-2)):
            newConn = addNewConn(inpNeuron+2,inpNeuron,weight)
            connectors = connectors + newConn

    return connectors

def getHEdgeTopOrBottomFrom3x3OffExcite():
    INPSIZE = nealParameters.INPSIZE
    weight = hEdgeTopOrBottomThreeOffExciteWeight
    connectors = []
    for inpNeuron in range (0,nealParameters.neuronsPerVisionSubnet):
        col = inpNeuron % INPSIZE
        if (col > 0):
            newConn = addNewConn(inpNeuron-1,inpNeuron,weight)
            connectors = connectors + newConn
        if (col > 1):
            newConn = addNewConn(inpNeuron-2,inpNeuron,weight)
            connectors = connectors + newConn
        connectors = connectors + [(inpNeuron,inpNeuron,weight,
                                    nealParameters.DELAY)]
        if (col < (INPSIZE-1)):
            newConn = addNewConn(inpNeuron+1,inpNeuron,weight)
            connectors = connectors + newConn
        if (col < (INPSIZE-2)):
            newConn = addNewConn(inpNeuron+2,inpNeuron,weight)
            connectors = connectors + newConn

    return connectors

#def getHEdgeBottomFrom6x6OffInhib():
    INPSIZE = nealParameters.INPSIZE
    weight = hEdgeTopSixOffInhibWeight
    connectors = []
    for inpNeuron in range (0,nealParameters.neuronsPerVisionSubnet):
        col = inpNeuron % INPSIZE
        if (col > 3):
            newConn = addNewConn(inpNeuron-4,inpNeuron,weight)
            connectors = connectors + newConn
        if (col > 2):
            newConn = addNewConn(inpNeuron-3,inpNeuron,weight)
            connectors = connectors + newConn
        if (col > 1):
            newConn = addNewConn(inpNeuron-2,inpNeuron,weight)
            connectors = connectors + newConn
        if (col > 0):
            newConn = addNewConn(inpNeuron-1,inpNeuron,weight)
            connectors = connectors + newConn
        connectors = connectors + [(inpNeuron,inpNeuron,weight,
                                    nealParameters.DELAY)]
        if (col < (INPSIZE-1)):
            newConn = addNewConn(inpNeuron+1,inpNeuron,weight)
            connectors = connectors + newConn
        if (col < (INPSIZE-2)):
            newConn = addNewConn(inpNeuron+2,inpNeuron,weight)
            connectors = connectors + newConn
        if (col < (INPSIZE-3)):
            newConn = addNewConn(inpNeuron+3,inpNeuron,weight)
            connectors = connectors + newConn

    return connectors

def getHEdgeBottomFrom6x6OffInhib():
    INPSIZE = nealParameters.INPSIZE
    weight = hEdgeBottomSixOffInhibWeight
    connectors = []
    for inpNeuron in range (0,nealParameters.neuronsPerVisionSubnet):
        col = inpNeuron % INPSIZE
        if (col > 3): 
            if (nealParameters.simulator == 'spinnaker'):
                newConn = addNewConn(inpNeuron-(2*INPSIZE)-4,inpNeuron,weight)
            else:
                newConn = addNewConn(inpNeuron-(INPSIZE)-4,inpNeuron,weight)
            connectors = connectors + newConn
        if (col > 2): 
            if (nealParameters.simulator == 'spinnaker'):
                newConn = addNewConn(inpNeuron-(2*INPSIZE)-3,inpNeuron,weight)
            else:
                newConn = addNewConn(inpNeuron-(INPSIZE)-3,inpNeuron,weight)
            connectors = connectors + newConn
        if (col > 1):
            if (nealParameters.simulator == 'spinnaker'):
                newConn = addNewConn(inpNeuron-(2*INPSIZE)-2,inpNeuron,weight)
            else:
                newConn = addNewConn(inpNeuron-(INPSIZE)-2,inpNeuron,weight)
            connectors = connectors + newConn
        if (col > 0):
            if (nealParameters.simulator == 'spinnaker'):
                newConn = addNewConn(inpNeuron-(2*INPSIZE)-1,inpNeuron,weight)
            else:
                newConn = addNewConn(inpNeuron-(INPSIZE)-1,inpNeuron,weight)
            connectors = connectors + newConn
        if (nealParameters.simulator == 'spinnaker'):
            newConn = addNewConn(inpNeuron-(2*INPSIZE),inpNeuron,weight)
        else:
            newConn = addNewConn(inpNeuron-(INPSIZE),inpNeuron,weight)
        connectors = connectors + newConn 
        if (col < (INPSIZE-1)):
            if (nealParameters.simulator == 'spinnaker'):
                newConn = addNewConn(inpNeuron-(2*INPSIZE)+1,inpNeuron,weight)
            else:
                newConn = addNewConn(inpNeuron-(INPSIZE)+1,inpNeuron,weight)
            connectors = connectors + newConn
        if (col < (INPSIZE-2)):
            if (nealParameters.simulator == 'spinnaker'):
                newConn = addNewConn(inpNeuron-(2*INPSIZE)+2,inpNeuron,weight)
            else:
                newConn = addNewConn(inpNeuron-(INPSIZE)+2,inpNeuron,weight)
            connectors = connectors + newConn
        if (col < (INPSIZE-3)):
            if (nealParameters.simulator == 'spinnaker'):
                newConn = addNewConn(inpNeuron-(2*INPSIZE)+3,inpNeuron,weight)
            else:
                newConn = addNewConn(inpNeuron-(INPSIZE)+3,inpNeuron,weight)
            connectors = connectors + newConn
        if (col < (INPSIZE-4)):
            if (nealParameters.simulator == 'spinnaker'):
                newConn = addNewConn(inpNeuron-(2*INPSIZE)+4,inpNeuron,weight)
            else:
                newConn = addNewConn(inpNeuron-(INPSIZE)+4,inpNeuron,weight)
            connectors = connectors + newConn

    return connectors

def getHEdgeBottomFrom9x9OffInhib():
    INPSIZE = nealParameters.INPSIZE
    weight = hEdgeBottomNineOffInhibWeight
    connectors = []
    for inpNeuron in range (0,nealParameters.neuronsPerVisionSubnet):
        col = inpNeuron % INPSIZE
        if (col > 3): 
            newConn = addNewConn(inpNeuron-(2*INPSIZE)-4,inpNeuron,weight)
            connectors = connectors + newConn
        if (col > 2): 
            newConn = addNewConn(inpNeuron-(2*INPSIZE)-3,inpNeuron,weight)
            connectors = connectors + newConn
        if (col > 1):
            newConn = addNewConn(inpNeuron-(2*INPSIZE)-2,inpNeuron,weight)
            connectors = connectors + newConn
        if (col > 0):
            newConn = addNewConn(inpNeuron-(2*INPSIZE)-1,inpNeuron,weight)
            connectors = connectors + newConn
        newConn = addNewConn(inpNeuron-(2*INPSIZE),inpNeuron,weight)
        connectors = connectors + newConn 
        if (col < (INPSIZE-1)):
            newConn = addNewConn(inpNeuron-(2*INPSIZE)+1,inpNeuron,weight)
            connectors = connectors + newConn
        if (col < (INPSIZE-2)):
            newConn = addNewConn(inpNeuron-(2*INPSIZE)+2,inpNeuron,weight)
            connectors = connectors + newConn
        if (col < (INPSIZE-3)):
            newConn = addNewConn(inpNeuron-(2*INPSIZE)+3,inpNeuron,weight)
            connectors = connectors + newConn
        if (col < (INPSIZE-4)):
            newConn = addNewConn(inpNeuron-(2*INPSIZE)+4,inpNeuron,weight)
            connectors = connectors + newConn

    return connectors

def getHEdgeTopFrom6x6OffInhib():
    INPSIZE = nealParameters.INPSIZE
    weight = hEdgeTopSixOffInhibWeight
    connectors = []
    for inpNeuron in range (0,nealParameters.neuronsPerVisionSubnet):
        col = inpNeuron % INPSIZE

        if (col > 3):
            if (nealParameters.simulator == 'spinnaker'):
                newConn = addNewConn(inpNeuron+INPSIZE-4,inpNeuron,weight)
            else:
                newConn = addNewConn(inpNeuron-4,inpNeuron,weight)
            connectors = connectors + newConn
        if (col > 2):
            if (nealParameters.simulator == 'spinnaker'):
                newConn = addNewConn(inpNeuron+INPSIZE-3,inpNeuron,weight)
            else:
                newConn = addNewConn(inpNeuron-3,inpNeuron,weight)
            connectors = connectors + newConn
        if (col > 1): 
            if (nealParameters.simulator == 'spinnaker'):
                newConn = addNewConn(inpNeuron+INPSIZE-2,inpNeuron,weight)
            else:
                newConn = addNewConn(inpNeuron-2,inpNeuron,weight)
            connectors = connectors + newConn
        if (col > 0):
            if (nealParameters.simulator == 'spinnaker'):
                newConn = addNewConn(inpNeuron+INPSIZE-1,inpNeuron,weight)
            else:
                newConn = addNewConn(inpNeuron-1,inpNeuron,weight)
            connectors = connectors + newConn
        if (nealParameters.simulator == 'spinnaker'):
            connectors = connectors + [(inpNeuron+INPSIZE,inpNeuron,weight,
                                    nealParameters.DELAY)]
        else:
            connectors = connectors + [(inpNeuron,inpNeuron,weight,
                                    nealParameters.DELAY)]
        if (col < (INPSIZE-1)):
            if (nealParameters.simulator == 'spinnaker'):
                newConn = addNewConn(inpNeuron+INPSIZE+1,inpNeuron,weight)
            else:
                newConn = addNewConn(inpNeuron+1,inpNeuron,weight)
            connectors = connectors + newConn
        if (col < (INPSIZE-2)):
            if (nealParameters.simulator == 'spinnaker'):
                newConn = addNewConn(inpNeuron+INPSIZE+2,inpNeuron,weight)
            else:
                newConn = addNewConn(inpNeuron+2,inpNeuron,weight)
            connectors = connectors + newConn
        if (col < (INPSIZE-3)):
            if (nealParameters.simulator == 'spinnaker'):
                newConn = addNewConn(inpNeuron+INPSIZE+3,inpNeuron,weight)
            else:
                newConn = addNewConn(inpNeuron+3,inpNeuron,weight)
            connectors = connectors + newConn

    return connectors

def getHEdgeTopFrom9x9OffInhib():
    INPSIZE = nealParameters.INPSIZE
    weight = hEdgeTopNineOffInhibWeight
    connectors = []
    for inpNeuron in range (0,nealParameters.neuronsPerVisionSubnet):
        col = inpNeuron % INPSIZE
        if (col > 3):
            newConn = addNewConn(inpNeuron-4,inpNeuron,weight)
            connectors = connectors + newConn
        if (col > 2):
            newConn = addNewConn(inpNeuron-3,inpNeuron,weight)
            connectors = connectors + newConn
        if (col > 1):
            newConn = addNewConn(inpNeuron-2,inpNeuron,weight)
            connectors = connectors + newConn
        if (col > 0):
            newConn = addNewConn(inpNeuron-1,inpNeuron,weight)
            connectors = connectors + newConn
        connectors = connectors + [(inpNeuron,inpNeuron,weight,
                                    nealParameters.DELAY)]
        if (col < (INPSIZE-1)):
            newConn = addNewConn(inpNeuron+1,inpNeuron,weight)
            connectors = connectors + newConn
        if (col < (INPSIZE-2)):
            newConn = addNewConn(inpNeuron+2,inpNeuron,weight)
            connectors = connectors + newConn
        if (col < (INPSIZE-3)):
            newConn = addNewConn(inpNeuron+3,inpNeuron,weight)
            connectors = connectors + newConn

    return connectors

def getVEdgeLeftOrRightFrom3x3OffExcite():
    INPSIZE = nealParameters.INPSIZE
    weight = vEdgeLeftOrRightThreeOffExciteWeight
    connectors = []
    for inpNeuron in range (0,nealParameters.neuronsPerVisionSubnet):
        row = inpNeuron / INPSIZE
        if (row > 0):
            newConn = addNewConn(inpNeuron-INPSIZE,inpNeuron,weight)
            connectors = connectors + newConn
        if (row > 1):
            newConn = addNewConn(inpNeuron-(2*INPSIZE),inpNeuron,weight)
            connectors = connectors + newConn
        connectors = connectors + [(inpNeuron,inpNeuron,weight,
                                    nealParameters.DELAY)]
        if (row < (INPSIZE-1)):
            newConn = addNewConn(inpNeuron+INPSIZE,inpNeuron,weight)
            connectors = connectors + newConn

    return connectors

def getVEdgeRightFrom9x9OffInhib():
    INPSIZE = nealParameters.INPSIZE
    weight = vEdgeLeftNineOffInhibWeight
    connectors = []
    for inpNeuron in range (0,nealParameters.neuronsPerVisionSubnet):
        row = inpNeuron / INPSIZE
        for rowOff in range (-1,2):
            for colOff in range (-2,2):
                newConn = addNewConn(inpNeuron+colOff+(rowOff*INPSIZE),
                                     inpNeuron,weight)
                connectors = connectors + newConn

    return connectors

def getVEdgeLeftFrom9x9OffInhib():
    INPSIZE = nealParameters.INPSIZE
    weight = vEdgeRightNineOffInhibWeight
    connectors = []
    for inpNeuron in range (0,nealParameters.neuronsPerVisionSubnet):
        row = inpNeuron / INPSIZE
        for rowOff in range (-1,2):
            for colOff in range (2,6):
                newConn = addNewConn(inpNeuron+colOff+(rowOff*INPSIZE),
                                     inpNeuron,weight)
                connectors = connectors + newConn
    return connectors


def getSEdgeTopOrBottomFrom3x3OnExcite():
    INPSIZE = nealParameters.INPSIZE
    weight = sEdgeTopOrBottomThreeOnExciteWeight

    connectors = []
    for inpNeuron in range (0,nealParameters.neuronsPerVisionSubnet):
        col = inpNeuron % INPSIZE
        row = inpNeuron / INPSIZE
        newConn = addNewConn(inpNeuron,inpNeuron,weight)
        connectors = connectors + newConn
        if (col > 0) and (row < INPSIZE):
            fromNeuron = inpNeuron + INPSIZE -1
            newConn = addNewConn(fromNeuron,inpNeuron,weight)
            connectors = connectors + newConn
        if (col > 1) and (row < (INPSIZE-1)):
            fromNeuron = inpNeuron + (2*INPSIZE) -2
            newConn = addNewConn(fromNeuron,inpNeuron,weight)
            connectors = connectors + newConn
        if (col < (INPSIZE-1)) and (row > 0):
            fromNeuron = inpNeuron - INPSIZE + 1
            newConn = addNewConn(fromNeuron,inpNeuron,weight)
            connectors = connectors + newConn
        if (col < (INPSIZE-2)) and (row > 1):
            fromNeuron = inpNeuron - (2*INPSIZE) +2
            newConn = addNewConn(fromNeuron,inpNeuron,weight)
            connectors = connectors + newConn
    return connectors

def getSEdgeTopOrBottomFrom3x3OffExcite():
    INPSIZE = nealParameters.INPSIZE
    weight = sEdgeTopOrBottomThreeOffExciteWeight

    connectors = []
    for inpNeuron in range (0,nealParameters.neuronsPerVisionSubnet):
        col = inpNeuron % INPSIZE
        row = inpNeuron / INPSIZE
        newConn = addNewConn(inpNeuron,inpNeuron,weight)
        connectors = connectors + newConn
        if (col > 0) and (row < INPSIZE):
            fromNeuron = inpNeuron + INPSIZE -1
            newConn = addNewConn(fromNeuron,inpNeuron,weight)
            connectors = connectors + newConn
        if (col > 1) and (row < (INPSIZE-1)):
            fromNeuron = inpNeuron + (2*INPSIZE) -2
            newConn = addNewConn(fromNeuron,inpNeuron,weight)
            connectors = connectors + newConn
        if (col < (INPSIZE-1)) and (row > 0):
            fromNeuron = inpNeuron - INPSIZE + 1
            newConn = addNewConn(fromNeuron,inpNeuron,weight)
            connectors = connectors + newConn
        if (col < (INPSIZE-2)) and (row > 1):
            fromNeuron = inpNeuron - (2*INPSIZE) +2
            newConn = addNewConn(fromNeuron,inpNeuron,weight)
            connectors = connectors + newConn
    return connectors


def getSEdgeTopOrBottomFrom6x6OffInhib():
    INPSIZE = nealParameters.INPSIZE
    weight =  sEdgeTopOrBottomSixOffInhibWeight
    connectors = []
    for inpNeuron in range (0,nealParameters.neuronsPerVisionSubnet):
        row = inpNeuron / INPSIZE
        if (row < INPSIZE -2):
            newConn = addNewConn(inpNeuron,inpNeuron+INPSIZE,weight)
            connectors = connectors + newConn
        if (row < INPSIZE -3):
            newConn = addNewConn(inpNeuron,inpNeuron+(2*INPSIZE),weight)
            connectors = connectors + newConn

    return connectors

def getSEdgeTopOrBottomFrom9x9OffInhib():
    INPSIZE = nealParameters.INPSIZE
    weight = sEdgeTopOrBottomNineOffInhibWeight
    connectors = []
    for inpNeuron in range (0,nealParameters.neuronsPerVisionSubnet):
        row = inpNeuron / INPSIZE
        if (row > 0):
            newConn = addNewConn(inpNeuron,inpNeuron-INPSIZE,weight)
            connectors = connectors + newConn
        if (row > 1):
            newConn = addNewConn(inpNeuron,inpNeuron-(2*INPSIZE),weight)
            connectors = connectors + newConn
    return connectors

def getSEdgeTopFrom6x6OffInhib():
    INPSIZE = nealParameters.INPSIZE
    weight = sEdgeTopSixOffInhibWeight
    connectors = []
    for inpNeuron in range (0,nealParameters.neuronsPerVisionSubnet):
        col = inpNeuron % INPSIZE
        row = inpNeuron / INPSIZE
        if (col < INPSIZE-1):
            newConn = addNewConn(inpNeuron,inpNeuron+1,weight)
            connectors = connectors + newConn
            if (row > 0):
                newConn = addNewConn(inpNeuron,inpNeuron+1-INPSIZE,weight)
                connectors = connectors + newConn
            if (row < INPSIZE-1):
                newConn = addNewConn(inpNeuron,inpNeuron+1+INPSIZE,weight)
                connectors = connectors + newConn

        newConn = addNewConn(inpNeuron,inpNeuron,weight)
        connectors = connectors + newConn
        if (col > 0):
            newConn = addNewConn(inpNeuron,inpNeuron-1,weight)
            connectors = connectors + newConn
            if (row < INPSIZE-1):
                newConn = addNewConn(inpNeuron,inpNeuron-1+INPSIZE,weight)
                connectors = connectors + newConn

        if (col > 1):
            newConn = addNewConn(inpNeuron,inpNeuron-2,weight)
            connectors = connectors + newConn
            if (row < INPSIZE-1):
                newConn = addNewConn(inpNeuron,inpNeuron-2+INPSIZE,weight)
                connectors = connectors + newConn

    return connectors

def getSEdgeTopFrom9x9OffInhib():
    INPSIZE = nealParameters.INPSIZE
    weight = sEdgeTopNineOffInhibWeight
    connectors = []
    for inpNeuron in range (0,nealParameters.neuronsPerVisionSubnet):
        col = inpNeuron % INPSIZE
        row = inpNeuron / INPSIZE
        if (col < INPSIZE-1):
            newConn = addNewConn(inpNeuron,inpNeuron+1,weight)
            connectors = connectors + newConn
            if (row > 0):
                newConn = addNewConn(inpNeuron,inpNeuron+1-INPSIZE,weight)
                connectors = connectors + newConn
            if (row < INPSIZE-1):
                newConn = addNewConn(inpNeuron,inpNeuron+1+INPSIZE,weight)
                connectors = connectors + newConn

        newConn = addNewConn(inpNeuron,inpNeuron,weight)
        connectors = connectors + newConn
        if (col > 0):
            newConn = addNewConn(inpNeuron,inpNeuron-1,weight)
            connectors = connectors + newConn
            if (row < INPSIZE-1):
                newConn = addNewConn(inpNeuron,inpNeuron-1+INPSIZE,weight)
                connectors = connectors + newConn

        if (col > 1):
            newConn = addNewConn(inpNeuron,inpNeuron-2,weight)
            connectors = connectors + newConn
            if (row < INPSIZE-1):
                newConn = addNewConn(inpNeuron,inpNeuron-2+INPSIZE,weight)
                connectors = connectors + newConn

    return connectors

#from 1 left  and 2left
def getSEdgeBottomFrom6x6OffInhib():
    INPSIZE = nealParameters.INPSIZE
    weight = sEdgeBottomSixOffInhibWeight
    connectors = []
    for inpNeuron in range (0,nealParameters.neuronsPerVisionSubnet):
        col = inpNeuron % INPSIZE
        row = inpNeuron / INPSIZE
        if (col > 0):
            fromNeuron = inpNeuron -1
            newConn = addNewConn(fromNeuron,inpNeuron,weight)
            connectors = connectors + newConn
        if (col > 1):
            fromNeuron = inpNeuron -2
            newConn = addNewConn(fromNeuron,inpNeuron,weight)
            connectors = connectors + newConn
    return connectors



def getSEdgeBottomFrom9x9OffInhib():
    INPSIZE = nealParameters.INPSIZE
    weight = sEdgeBottomNineOffInhibWeight
    connectors = []
    for inpNeuron in range (0,nealParameters.neuronsPerVisionSubnet):
        col = inpNeuron % INPSIZE
        row = inpNeuron / INPSIZE
        if (col < INPSIZE-1):
            newConn = addNewConn(inpNeuron,inpNeuron+1,weight)
            connectors = connectors + newConn
            if (row > 0):
                newConn = addNewConn(inpNeuron,inpNeuron+1-INPSIZE,weight)
                connectors = connectors + newConn

        if (col < INPSIZE-2):
            newConn = addNewConn(inpNeuron,inpNeuron+2,weight)
            connectors = connectors + newConn
            if (row > 0):
                newConn = addNewConn(inpNeuron,inpNeuron+2-INPSIZE,weight)
                connectors = connectors + newConn

        if (col < INPSIZE-3):
            newConn = addNewConn(inpNeuron,inpNeuron+3,weight)
            connectors = connectors + newConn
            if (row > 0):
                newConn = addNewConn(inpNeuron,inpNeuron+3-INPSIZE,weight)
                connectors = connectors + newConn

        if (col < INPSIZE-4):
            newConn = addNewConn(inpNeuron,inpNeuron+4,weight)
            connectors = connectors + newConn

    return connectors


def getBEdgeTopOrBottomFrom3x3OnExcite():
    INPSIZE = nealParameters.INPSIZE
    weight = bEdgeTopOrBottomThreeOnExciteWeight

    connectors = []
    for inpNeuron in range (0,nealParameters.neuronsPerVisionSubnet):
        col = inpNeuron % INPSIZE
        row = inpNeuron / INPSIZE
        newConn = addNewConn(inpNeuron,inpNeuron,weight)
        connectors = connectors + newConn
        if (col < (INPSIZE-1)) and (row < (INPSIZE-1)):
            fromNeuron = inpNeuron + INPSIZE +1
            newConn = addNewConn(fromNeuron,inpNeuron,weight)
            connectors = connectors + newConn
        if (col < (INPSIZE-2)) and (row < (INPSIZE-2)):
            fromNeuron = inpNeuron + (2*INPSIZE) +2
            newConn = addNewConn(fromNeuron,inpNeuron,weight)
            connectors = connectors + newConn
        if (col > 0) and (row > 0):
            fromNeuron = inpNeuron - INPSIZE - 1
            newConn = addNewConn(fromNeuron,inpNeuron,weight)
            connectors = connectors + newConn
        if (col > 1) and (row > 1):
            fromNeuron = inpNeuron - (2*INPSIZE) -2
            newConn = addNewConn(fromNeuron,inpNeuron,weight)
            connectors = connectors + newConn
    return connectors

def getBEdgeTopOrBottomFrom6x6OnInhib():
    INPSIZE = nealParameters.INPSIZE
    weight = bEdgeTopOrBottomSixOnInhibWeight

    connectors = []
    for inpNeuron in range (0,nealParameters.neuronsPerVisionSubnet):
        col = inpNeuron % INPSIZE
        row = inpNeuron / INPSIZE
        newConn = addNewConn(inpNeuron,inpNeuron,weight)
        connectors = connectors + newConn
    return connectors

def getBEdgeTopOrBottomFrom3x3OffExcite():
    INPSIZE = nealParameters.INPSIZE
    weight = bEdgeTopOrBottomThreeOffExciteWeight
    connectors = []
    for inpNeuron in range (0,nealParameters.neuronsPerVisionSubnet):
        col = inpNeuron % INPSIZE
        row = inpNeuron / INPSIZE
        newConn = addNewConn(inpNeuron,inpNeuron,weight)
        connectors = connectors + newConn
        if (col < (INPSIZE-1)) and (row < (INPSIZE-1)):
            fromNeuron = inpNeuron + INPSIZE +1
            newConn = addNewConn(fromNeuron,inpNeuron,weight)
            connectors = connectors + newConn
        if (col < (INPSIZE-2)) and (row < (INPSIZE-2)):
            fromNeuron = inpNeuron + (2*INPSIZE) +2
            newConn = addNewConn(fromNeuron,inpNeuron,weight)
            connectors = connectors + newConn
        if (col > 0) and (row > 0):
            fromNeuron = inpNeuron - INPSIZE - 1
            newConn = addNewConn(fromNeuron,inpNeuron,weight)
            connectors = connectors + newConn
        if (col > 1) and (row > 1):
            fromNeuron = inpNeuron - (2*INPSIZE) -2
            newConn = addNewConn(fromNeuron,inpNeuron,weight)
            connectors = connectors + newConn
    return connectors

#from self, 1 left, 2 left, 1 up and 3 left, 1 up, 2up and 1 left, 
def getBEdgeTopFrom6x6OffInhib():
    INPSIZE = nealParameters.INPSIZE
    weight = bEdgeTopSixOffInhibWeight

    connectors = []
    for inpNeuron in range (0,nealParameters.neuronsPerVisionSubnet):
        col = inpNeuron % INPSIZE
        row = inpNeuron / INPSIZE
        newConn = addNewConn(inpNeuron,inpNeuron,weight)
        connectors = connectors + newConn
        if (col > 0):
            fromNeuron = inpNeuron - 1
            newConn = addNewConn(fromNeuron,inpNeuron,weight)
            connectors = connectors + newConn
        if (col > 1):
            fromNeuron = inpNeuron - 2
            newConn = addNewConn(fromNeuron,inpNeuron,weight)
            connectors = connectors + newConn
        if (row > 0) and (col > 2):
            fromNeuron = inpNeuron - INPSIZE - 3
            newConn = addNewConn(fromNeuron,inpNeuron,weight)
            connectors = connectors + newConn
        if (nealParameters.simulator == 'spinnaker'):
            if (row < 1) and (col > 0):
                fromNeuron = inpNeuron + INPSIZE - 1
                newConn = addNewConn(fromNeuron,inpNeuron,weight)
                connectors = connectors + newConn
            if (row < 1) and (col > 2):
                fromNeuron = inpNeuron + INPSIZE - 2
                newConn = addNewConn(fromNeuron,inpNeuron,weight)
                connectors = connectors + newConn
            if (row < 2) and (col > 0):
                fromNeuron = inpNeuron + (2*INPSIZE) - 1
                newConn = addNewConn(fromNeuron,inpNeuron,weight)
                connectors = connectors + newConn
            if (row < 2) and (col > 1):
                fromNeuron = inpNeuron + (2*INPSIZE) - 2
                newConn = addNewConn(fromNeuron,inpNeuron,weight)
                connectors = connectors + newConn
            if (row < 2):
                fromNeuron = inpNeuron + (2*INPSIZE)
                newConn = addNewConn(fromNeuron,inpNeuron,weight)
                connectors = connectors + newConn
            if (row < 3):
                fromNeuron = inpNeuron + (3*INPSIZE)
                newConn = addNewConn(fromNeuron,inpNeuron,weight)
                connectors = connectors + newConn
        else:
            if (row > 0):
                fromNeuron = inpNeuron - INPSIZE
                newConn = addNewConn(fromNeuron,inpNeuron,weight)
                connectors = connectors + newConn
            if (col > 0) and (row > 1):
                fromNeuron = inpNeuron - (2*INPSIZE) -1
                newConn = addNewConn(fromNeuron,inpNeuron,weight)
                connectors = connectors + newConn

    return connectors

def getBEdgeTopFrom9x9OffInhib():
    INPSIZE = nealParameters.INPSIZE
    weight = bEdgeTopNineOffInhibWeight

    connectors = []
    for inpNeuron in range (0,nealParameters.neuronsPerVisionSubnet):
        col = inpNeuron % INPSIZE
        row = inpNeuron / INPSIZE
        if (row < INPSIZE-1):
            fromNeuron = inpNeuron + INPSIZE
            newConn = addNewConn(fromNeuron,inpNeuron,weight)
            connectors = connectors + newConn
        if (row < INPSIZE-2):
            fromNeuron = inpNeuron + (2*INPSIZE)
            newConn = addNewConn(fromNeuron,inpNeuron,weight)
            connectors = connectors + newConn
        if (row > 0) and (col > 2):
            fromNeuron = inpNeuron - INPSIZE - 3
            newConn = addNewConn(fromNeuron,inpNeuron,weight)
            connectors = connectors + newConn
    return connectors

#1 up, 2 up, 1 up and 3 left
def getBEdgeBottomFrom9x9OffInhib():
    INPSIZE = nealParameters.INPSIZE
    weight = bEdgeBottomNineOffInhibWeight

    connectors = []
    for inpNeuron in range (0,nealParameters.neuronsPerVisionSubnet):
        col = inpNeuron % INPSIZE
        row = inpNeuron / INPSIZE
        if (row < INPSIZE-1):
            fromNeuron = inpNeuron + INPSIZE
            newConn = addNewConn(fromNeuron,inpNeuron,weight)
            connectors = connectors + newConn
        if (row < INPSIZE-2):
            fromNeuron = inpNeuron + (2*INPSIZE)
            newConn = addNewConn(fromNeuron,inpNeuron,weight)
            connectors = connectors + newConn
        if (row > 0) and (col > 2):
            fromNeuron = inpNeuron - INPSIZE - 3
            newConn = addNewConn(fromNeuron,inpNeuron,weight)
            connectors = connectors + newConn
    return connectors

#self, 1 right 1 down, 2 down right 1
def getBEdgeBottomFrom6x6OffInhib():
    INPSIZE = nealParameters.INPSIZE
    weight = bEdgeBottomSixOffInhibWeight

    connectors = []
    for inpNeuron in range (0,nealParameters.neuronsPerVisionSubnet):
        col = inpNeuron % INPSIZE
        row = inpNeuron / INPSIZE
        newConn = addNewConn(inpNeuron,inpNeuron,weight)
        connectors = connectors + newConn
        if (col < INPSIZE-1):
            fromNeuron = inpNeuron + 1
            newConn = addNewConn(fromNeuron,inpNeuron,weight)
            connectors = connectors + newConn
        if (row < INPSIZE-1):
            fromNeuron = inpNeuron - INPSIZE
            newConn = addNewConn(fromNeuron,inpNeuron,weight)
            connectors = connectors + newConn
        if (row < INPSIZE-2) and (col < INPSIZE-1):
            fromNeuron = inpNeuron + (2*INPSIZE) + 1
            newConn = addNewConn(fromNeuron,inpNeuron,weight)
            connectors = connectors + newConn
        if (nealParameters.simulator == 'spinnaker'):
            if (col < INPSIZE-3):
                fromNeuron = inpNeuron + 3 - INPSIZE
                newConn = addNewConn(fromNeuron,inpNeuron,weight)
                connectors = connectors + newConn
            if (col < INPSIZE-2):
                fromNeuron = inpNeuron + 2
                newConn = addNewConn(fromNeuron,inpNeuron,weight)
                connectors = connectors + newConn
            if (row < INPSIZE-2):
                fromNeuron = inpNeuron - (2*INPSIZE)
                newConn = addNewConn(fromNeuron,inpNeuron,weight)
                connectors = connectors + newConn
            if (row < INPSIZE-1) and (col < INPSIZE-1):
                fromNeuron = inpNeuron + INPSIZE + 1
                newConn = addNewConn(fromNeuron,inpNeuron,weight)
                connectors = connectors + newConn
                
        
    return connectors


